## ipxe-precise 1.0.0+git

=== src/Makefile ===
###############################################################################
#
# Initialise various variables
#

CLEANUP		:=
CFLAGS		:=
ASFLAGS		:=
LDFLAGS		:=
MAKEDEPS	:= Makefile

###############################################################################
#
# Locations of tools
#
HOST_CC		:= gcc
RM		:= rm -f
TOUCH		:= touch
MKDIR		:= mkdir
CP		:= cp
ECHO		:= echo
PRINTF		:= printf
PERL		:= perl
TRUE		:= true
CC		:= $(CROSS_COMPILE)gcc
CPP		:= $(CC) -E
AS		:= $(CROSS_COMPILE)as
LD		:= $(CROSS_COMPILE)ld
SIZE		:= $(CROSS_COMPILE)size
AR		:= $(CROSS_COMPILE)ar
RANLIB		:= $(CROSS_COMPILE)ranlib
OBJCOPY		:= $(CROSS_COMPILE)objcopy
NM		:= $(CROSS_COMPILE)nm
OBJDUMP		:= $(CROSS_COMPILE)objdump
PARSEROM	:= ./util/parserom.pl
FIXROM		:= ./util/fixrom.pl
SYMCHECK	:= ./util/symcheck.pl
SORTOBJDUMP	:= ./util/sortobjdump.pl
PADIMG		:= ./util/padimg.pl
LICENCE		:= ./util/licence.pl
NRV2B		:= ./util/nrv2b
ZBIN		:= ./util/zbin
ELF2EFI32	:= ./util/elf2efi32
ELF2EFI64	:= ./util/elf2efi64
EFIROM		:= ./util/efirom
ICCFIX		:= ./util/iccfix
EINFO		:= ./util/einfo
GENKEYMAP	:= ./util/genkeymap.pl
DOXYGEN		:= doxygen
BINUTILS_DIR	:= /usr
BFD_DIR		:= $(BINUTILS_DIR)
ZLIB_DIR	:= /usr

###############################################################################
#
# SRCDIRS lists all directories containing source files.
#
SRCDIRS		:=
SRCDIRS		+= libgcc
SRCDIRS		+= core
SRCDIRS		+= net net/tcp net/udp net/infiniband net/80211
SRCDIRS		+= image
SRCDIRS		+= drivers/bus
SRCDIRS		+= drivers/net
SRCDIRS		+= drivers/net/e1000
SRCDIRS		+= drivers/net/e1000e
SRCDIRS		+= drivers/net/igb
SRCDIRS		+= drivers/net/igbvf
SRCDIRS		+= drivers/net/phantom
SRCDIRS		+= drivers/net/rtl818x
SRCDIRS		+= drivers/net/ath
SRCDIRS		+= drivers/net/ath/ath5k
SRCDIRS		+= drivers/net/ath/ath9k
SRCDIRS		+= drivers/net/vxge
SRCDIRS		+= drivers/net/efi
SRCDIRS		+= drivers/block
SRCDIRS		+= drivers/nvs
SRCDIRS		+= drivers/bitbash
SRCDIRS		+= drivers/infiniband
SRCDIRS		+= interface/pxe interface/efi interface/smbios
SRCDIRS		+= interface/bofm
SRCDIRS		+= tests
SRCDIRS		+= crypto crypto/axtls crypto/matrixssl
SRCDIRS		+= hci hci/commands hci/tui
SRCDIRS		+= hci/mucurses hci/mucurses/widgets
SRCDIRS		+= hci/keymap
SRCDIRS		+= usr
SRCDIRS		+= config

# NON_AUTO_SRCS lists files that are excluded from the normal
# automatic build system.
#
NON_AUTO_SRCS	:=
NON_AUTO_SRCS	+= drivers/net/prism2.c

# INCDIRS lists the include path
#
INCDIRS		:=
INCDIRS		+= include .

###############################################################################
#
# Default build target: build the most common targets and print out a
# helpfully suggestive message
#
ALL		:= bin/blib.a bin/ipxe.dsk bin/ipxe.lkrn bin/ipxe.iso \
		   bin/ipxe.usb bin/undionly.kpxe bin/rtl8139.rom
all : $(ALL)
	@$(ECHO) '==========================================================='
	@$(ECHO)
	@$(ECHO) 'To create a bootable floppy, type'
	@$(ECHO) '    cat bin/ipxe.dsk > /dev/fd0'
	@$(ECHO) 'where /dev/fd0 is your floppy drive.  This will erase any'
	@$(ECHO) 'data already on the disk.'
	@$(ECHO)
	@$(ECHO) 'To create a bootable USB key, type'
	@$(ECHO) '    cat bin/ipxe.usb > /dev/sdX'
	@$(ECHO) 'where /dev/sdX is your USB key, and is *not* a real hard'
	@$(ECHO) 'disk on your system.  This will erase any data already on'
	@$(ECHO) 'the USB key.'
	@$(ECHO)
	@$(ECHO) 'To create a bootable CD-ROM, burn the ISO image '
	@$(ECHO) 'bin/ipxe.iso to a blank CD-ROM.'
	@$(ECHO)
	@$(ECHO) 'These images contain drivers for all supported cards.  You'
	@$(ECHO) 'can build more customised images, and ROM images, using'
	@$(ECHO) '    make bin/<rom-name>.<output-format>'
	@$(ECHO)
	@$(ECHO) '==========================================================='

###############################################################################
#
# Comprehensive build target: build a selection of cross-platform
# targets to expose potential build errors that show up only on
# certain platforms
#
everything :
	$(Q)$(MAKE) --no-print-directory $(ALL) \
		bin-i386-efi/ipxe.efi bin-i386-efi/ipxe.efidrv \
		bin-i386-efi/ipxe.efirom \
		bin-x86_64-efi/ipxe.efi bin-x86_64-efi/ipxe.efidrv \
		bin-x86_64-efi/ipxe.efirom \
		bin-i386-linux/tap.linux bin-x86_64-linux/tap.linux

###############################################################################
#
# Build targets that do nothing but might be tried by users
#
configure :
	@$(ECHO) "No configuration needed."

install :
	@$(ECHO) "No installation required."

###############################################################################
#
# Version number calculations
#
VERSION_MAJOR	= 1
VERSION_MINOR	= 0
VERSION_PATCH	= 0
EXTRAVERSION	= +
MM_VERSION	= $(VERSION_MAJOR).$(VERSION_MINOR)
VERSION		= $(MM_VERSION).$(VERSION_PATCH)$(EXTRAVERSION)
CFLAGS		+= -DVERSION_MAJOR=$(VERSION_MAJOR) \
		   -DVERSION_MINOR=$(VERSION_MINOR) \
		   -DVERSION_PATCH=$(VERSION_PATCH) \
		   -DVERSION=\"$(VERSION)\"
IDENT		= '$(@F) $(VERSION) (GPL) ipxe.org'
version :
	@$(ECHO) $(VERSION)

###############################################################################
#
# Drag in the bulk of the build system
#

MAKEDEPS	+= Makefile.housekeeping
include Makefile.housekeeping

=== src/arch/i386/Makefile ===
# Force i386-only instructions
#
CFLAGS		+= -march=i386

# Code size reduction.
#
CFLAGS		+= -fomit-frame-pointer

# Code size reduction.
#
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -fstrength-reduce
endif

# Code size reduction.  gcc3 needs a different syntax to gcc2 if you
# want to avoid spurious warnings.
#
ifeq ($(CCTYPE),gcc)
GCC_VERSION	:= $(subst ., ,$(shell $(CC) -dumpversion))
GCC_MAJOR	:= $(firstword $(GCC_VERSION))
ifeq ($(GCC_MAJOR),2)
CFLAGS		+= -malign-jumps=1 -malign-loops=1 -malign-functions=1
else
CFLAGS		+= -falign-jumps=1 -falign-loops=1 -falign-functions=1
endif # gcc2
endif # gcc

# Code size reduction.  This is almost always a win.  The kernel uses
# it, too.
#
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -mpreferred-stack-boundary=2
endif

# Code size reduction.  Use regparm for all functions - C functions
# called from assembly (or vice versa) need __asmcall now
#
CFLAGS		+= -mregparm=3

# Code size reduction.  Use -mrtd (same __asmcall requirements as above)
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -mrtd
endif

# Code size reduction.  This is the logical complement to -mregparm=3.
# It doesn't currently buy us anything, but if anything ever tries to
# return small structures, let's be prepared
#
CFLAGS		+= -freg-struct-return

# Force 32-bit code even on an x86-64 machine
#
CFLAGS		+= -m32
ASFLAGS		+= --32
ifeq ($(HOST_OS),FreeBSD)
LDFLAGS		+= -m elf_i386_fbsd
else
LDFLAGS		+= -m elf_i386
endif

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
#
CFLAGS		+= -fshort-wchar

# We need to undefine the default macro "i386" when compiling .S
# files, otherwise ".arch i386" translates to ".arch 1"...
#
CFLAGS			+= -Ui386

# Locations of utilities
#
ISOLINUX_BIN_LIST	:= \
	$(ISOLINUX_BIN) \
	/usr/lib/syslinux/isolinux.bin \
	/usr/share/syslinux/isolinux.bin \
	/usr/local/share/syslinux/isolinux.bin
ISOLINUX_BIN	= $(firstword $(wildcard $(ISOLINUX_BIN_LIST)))

# i386-specific directories containing source files
#
SRCDIRS		+= arch/i386/core arch/i386/transitions arch/i386/prefix
SRCDIRS		+= arch/i386/firmware/pcbios
SRCDIRS		+= arch/i386/image
SRCDIRS		+= arch/i386/interface/pcbios
SRCDIRS		+= arch/i386/interface/pxe
SRCDIRS		+= arch/i386/interface/pxeparent
SRCDIRS 	+= arch/i386/interface/syslinux
SRCDIRS		+= arch/i386/hci/commands

# The various xxx_loader.c files are #included into core/loader.c and
# should not be compiled directly.
#
NON_AUTO_SRCS	+= arch/i386/core/aout_loader.c
NON_AUTO_SRCS	+= arch/i386/core/freebsd_loader.c
NON_AUTO_SRCS	+= arch/i386/core/wince_loader.c

# Include common x86 Makefile
#
MAKEDEPS	+= arch/x86/Makefile
include arch/x86/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/i386/Makefile.$(PLATFORM)
include arch/i386/Makefile.$(PLATFORM)

## ipxe-precise 1.0.0+git-3.55f6c88

=== debian/changelog ===
ipxe-precise (1.0.0+git-3.55f6c88-0ubuntu1.14.04.1) trusty-proposed; urgency=medium

  * First submission of ipxe-precise package (LP: #1374617)
    - rename source to ipxe-precise
    - rename binary to ipxe-kvm-precise
    - drop other binary packages.
    - add-isolinux-bin-path - Accomodate isolinux's new install path in
      utopic (not needed in trusty, but added in case toolchain updates
      through SRU or for ppa builds)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 24 Sep 2014 14:15:18 -0500

ipxe (1.0.0+git-3.55f6c88-0ubuntu1) precise; urgency=low

  [ Marc Cluet ]
  * New upstream snapshot.
  * Added rules for automatic git branch refresh.
  * Changed rom target from allbaseroms to allroms.
    - recommended behaviour by upstream, building all full roms is neither
      recommended nor a desired user experience
  * Added new target allqemu for qemu package.
    - created new build target to build full rom drivers just for qemu
      package purposes
  * Cleaned lintian errors from debian package
    - Removed brace extension in ipxe.install
    - Updated standards to 3.9.2
    - Fixed copyright file not machine readable

  [ James Page ]
  * Updated get-orig-source target to generate git snapshots inline
    with upstream version numbering being used by this package. 

 -- Marc Cluet <marc.cluet@ubuntu.com>  Fri, 10 Feb 2012 16:21:23 +0000

ipxe (1.0.0+git-2.149b50-1ubuntu4) precise; urgency=low

  * Add missing Breaks/Replaces for kvm-ipxe split in
    1.0.0+git-2.149b50-1ubuntu3 (LP: #905099).

 -- Robie Basak <robie.basak@ubuntu.com>  Fri, 16 Dec 2011 10:43:54 +0000

ipxe (1.0.0+git-2.149b50-1ubuntu3) precise; urgency=low

  * add new binary package, kvm-ipxe. The roms needed by kvm-ipxe are now only
    provided by it, so
    - make ipxe depend on kvm-ipxe.
    - ipxe.links: reverse the links

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Fri, 25 Nov 2011 12:58:48 -0600

ipxe (1.0.0+git-2.149b50-1ubuntu2) precise; urgency=low

  * Provide a new binary package, grub-ipxe - for ipxe usage via grub.
    - LP: #814038, Closes #626238

 -- Ben Howard <ben.howard@canonical.com>  Thu, 25 Aug 2011 11:03:52 -0600

ipxe (1.0.0+git-2.149b50-1ubuntu1) oneiric; urgency=low

  * Link Roms into /usr/share/qemu for consumption by
    qemu-kvm.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 18 Aug 2011 13:34:38 -0500

ipxe (1.0.0+git-2.149b50-1) unstable; urgency=low

  * New snapshot.

 -- Bastian Blank <waldi@debian.org>  Sun, 31 Jul 2011 20:57:02 +0200

ipxe (1.0.0+git-1.293e34-2) unstable; urgency=low

  * Add some missing copyrights and licenses to the copyright files.

 -- Bastian Blank <waldi@debian.org>  Mon, 11 Apr 2011 19:35:36 +0200

ipxe (1.0.0+git-1.293e34-1) unstable; urgency=low

  * Initial release (closes: #474034)
  * Remove drivers with binary-only firmware:
    - Remove bnx2 driver.
    - Remove linda infiniband driver.

 -- Bastian Blank <waldi@debian.org>  Sun, 03 Apr 2011 11:32:56 +0200

=== debian/control ===
Source: ipxe-precise
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Bastian Blank <waldi@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
 genisoimage, syslinux
Standards-Version: 3.9.2
Homepage: http://ipxe.org/
#Vcs-Git: git://git.debian.org/collab-maint/ipxe.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/ipxe.git;a=summary

Package: kvm-ipxe-precise
Architecture: all
Depends: ${misc:Depends}
Breaks: ipxe (<< 1.0.0+git-2.149b50-1ubuntu3)
Replaces: ipxe (<< 1.0.0+git-2.149b50-1ubuntu3)
Description: PXE ROM's for KVM vms migrated from 12.04
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 This package contains PXE ROM's made especially to pxeboot kvm vm's which
 are migrated from a 12.04 host.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	make -C src V=1 NO_WERROR=1 allqemu
	#make -C src V=1 NO_WERROR=1 all allroms allqemu bin/ipxe.pxe bin/ipxe.lkrn

override_dh_auto_clean:
	make -C src veryclean
	rm -f src/config/local/*

override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/kvm-ipxe-precise/usr/share/qemu
	mv src/bin/e1000_82540.rom   $(CURDIR)/debian/kvm-ipxe-precise/usr/share/qemu/pxe-e1000.rom.12.04
	mv src/bin/ne2k_isa.rom      $(CURDIR)/debian/kvm-ipxe-precise/usr/share/qemu/pxe-ne2k_isa.rom.12.04
	mv src/bin/pcnet32.rom       $(CURDIR)/debian/kvm-ipxe-precise/usr/share/qemu/pxe-pcnet32.rom.12.04
	mv src/bin/rtl8139.rom       $(CURDIR)/debian/kvm-ipxe-precise/usr/share/qemu/pxe-rtl8139.rom.12.04
	mv src/bin/virtio-net.rom    $(CURDIR)/debian/kvm-ipxe-precise/usr/share/qemu/pxe-virtio.rom.12.04

# Stuff for get-orig-source.
version_prefix := $(shell dpkg-parsechangelog | sed -ne 's/^Version.*git-\(.*\)\..*/\1/p')
# Git short hash is prefixed with version number - 
# increment for next snapshot
new_prefix := $(shell expr $(version_prefix) + 1)

get-orig-source:
	# Grab the latest snapshot of the upstream git repository
	[ ! -d ipxe-snapshot ] || rm -rf ipxe-snapshot
	git clone git://git.ipxe.org/ipxe.git ipxe-snapshot
	cd ipxe-snapshot && \
		commit=`git rev-parse --short HEAD` && \
		git archive --format=tar --prefix=ipxe-1.0.0+git-$(new_prefix).$${commit} master |\
			gzip -9 --no-name > ../../ipxe_1.0.0+git-$(new_prefix).$${commit}.orig.tar.gz
	rm -rf ipxe-snapshot
